dofile("seaquest/lib/printFont.lua")

-- ## status de carga do jogo ## --
controlaCargaJogo = 0
itensCarregados = "..."
while controlaCargaJogo < 100 do
	startDrawing()
    -- ## carregando imagens ## --
    if controlaCargaJogo == 0 then
        printFont(SCREEN_UP, 85,95,"LOADING ....")
    end 
    -- ## carregando bibliotecas ## --
    if controlaCargaJogo > 0 then
        printFont(SCREEN_UP, 85,95,"LOADING ....")
    end
    stopDrawing()
    -- ## carregando imagens ## --
    if controlaCargaJogo == 0 then 
        dofile("seaquest/lib/loadGraphics.lua")
        -- ## carrega as imagens do jogo ## --
        loadImages()
        controlaCargaJogo = 1
    end
    if controlaCargaJogo == 2 then
        dofile("seaquest/lib/modClass.lua")
        dofile("seaquest/lib/spriteClass.lua")
        dofile("seaquest/lib/collisionDetect.lua")
        dofile("seaquest/lib/gunClass.lua")
        dofile("seaquest/lib/controleInimigos.lua")
        dofile("seaquest/lib/oxigen.lua")
        dofile("seaquest/lib/controleSubSuperficie.lua")
        dofile("seaquest/lib/controleDificuldade.lua")
        dofile("seaquest/lib/controlaMovimentoMar.lua")
        dofile("seaquest/lib/fluxoGame.lua")
        dofile("seaquest/lib/fluxoApresentacao.lua")
        dofile("seaquest/lib/fluxoGameOver.lua")
        dofile("seaquest/lib/controlaMergulhadores.lua")
        dofile("seaquest/lib/soundClass.lua")
        controlaCargaJogo = 100
    end
    if controlaCargaJogo == 1 then 
        controlaCargaJogo = 2
    end
end

habilitaDebug = false


-- ## cria e carrega os modulos de som ## --
sndTiro     = Sound:new("seaquest/sounds/sndTiro.bin",150)
sndSirene   = Sound:new("seaquest/sounds/sndSirene.bin",500)
sndExplosao = Sound:new("seaquest/sounds/sndExplosao.bin",500)
sndPegou    = Sound:new("seaquest/sounds/sndPegou.bin",500)
sndRecarga  = Sound:new("seaquest/sounds/sndRecarga.bin",900)
sndTiro:Load()
sndSirene:Load()
sndExplosao:Load()
sndPegou:Load()
sndRecarga:Load()


-- ## verifica se o subamrino colidiu com os inimigos ## --
function verificaColisaoHero()
    local retornoFuncao = false
    -- ## verifica as colisoes do tiros com os inimigos ## --
	for n = 0, table.maxn(sprite) do
       if spriteCollided(hero,sprite[n]) then 
            retornoFuncao = true
       end
    end    
    return retornoFuncao
end

-- ## mata o inimigo ## --
function destroiHero()
    vidas = vidas - 1
    hero.posX = 100
    hero.posY = 100
    destroiInimigos()
    resgataMergulhador(99)
    totMergResgatados  = 0
    oxigenio =  100
    controlaSaidaOxigenio = 0
    estaNaSuperficie = false
    sndSirene.soundPlaying = false
    sndTiro.soundPlaying = false
    sndExplosao.soundPlaying = false
    sndPegou.soundPlaying = false
    sndRecarga.soundPlaying = false
    ctrlBonus = 16
end

bonusRegaste = false
ctrlBonus = 16
function bonificaRegaste()
    if ctrlBonus == 16 then 
        hero.points = hero.points + (totMergResgatados*sprMergulhador[0].points) 
        totMergResgatados  = 0
        totMergResgatados  = totMergResgatados - 1
        if totMergResgatados <=0 then
            bonusRegaste = false
            ctrlBonus = 16
        end
        ctrlBonus = 0
        sndPegou.soundActive=true
    end
    ctrlBonus = ctrlBonus + 1
    if ctrlBonus > 15 then 
        sndPegou.soundPlaying = false
        sndPegou.soundActive=false
    end 
end



-- ## Cria o personagem principal ## --
hero = Sprite:new(submarino,SCREEN_UP,0,100,100,1,2,32,12,3,0)

-- ## Cria a explosao do personagem ## --
boom = Sprite:new(explosao,SCREEN_UP,0,-100,-100,1,2,32,12,3,0)
boom.direction = 1

tempoExplosao   = 0
executaExplosao = false
function explodeSub()
    if tempoExplosao > 96 then
        tempoExplosao = 0
        destroiHero()
        executaExplosao = false
        -- ## posiciona a explosao no local onde estava o submarino ## --
        boom.posX = -200
        boom.posY = -200
    end 
    tempoExplosao = tempoExplosao + 1
    boom:putSprite()
end



-- ## controla os tiros  ## --
tiro = Gun:new(tiroSubmarino,SCREEN_UP,3,4,hero) --> imagem,tela,velocidade,qtd balas, sprite origem
tiro:createBullets()


-- ## controla o fluxo de execucao do jogo ##--
-- ## 0- Logo DC
-- ## 1- apresentacao 
-- ## 2- jogo
-- ## 3- game over
fluxoExecucaoGame = 1


while not Keys.newPress.Start do
	Controls.read()

	startDrawing()

    if fluxoExecucaoGame == 1 then 
        fluxoApresentacao()
    end 
    
    if fluxoExecucaoGame == 2 then 
        fluxoGame()
    end

    if fluxoExecucaoGame == 3 then 
        fluxoGameOver()
    end


    
    -- ## imprime o logo da DC na parte de baixo da tela ## --
    screen.drawFillRect(SCREEN_DOWN, 0, 0, 256, 192, Color.new(31, 31, 31))
    screen.blit(SCREEN_DOWN,22,65,dcLogo)

	
    stopDrawing()
end

-- ## libera memoria alocada para as imagens ## --
freeImages()

-- ## descarrega os sound da memoria -- ##
sndTiro:Destroy()
sndSirene:Destroy()
sndExplosao:Destroy()
sndPegou:Destroy()
sndRecarga:Destroy()


