function fluxoGame()
    -- ## inicio do fluxo de execucao do game ## --

    -- ## controla o  nivel de dificuldade ## --
    dificuldade()

    -- ## desenha a tela ## --
    screen.blit(SCREEN_UP,   0,    0,fundo)

    -- ## imprime o nome oxigen na parte de baixo da tela ## --
    printFont(SCREEN_UP,65,174,"OXIGEN:")

    -- ## controla o oxigenio ## -- 
    if not sndRecarga.soundPlaying then 
        carregaOxigenio()
    end
    controlaOxigenio(125,174)

    -- ## imprime o numero de mergulhadores resgatados ## --
    screen.blit(SCREEN_UP,210,170,mergulhador,0,0,16,16)
    printFont(SCREEN_UP  ,230,174,totMergResgatados)

    -- debug
    --printFont(SCREEN_DOWN,0,0,hero.frame)

    -- ## controla a area de movimentacao do submarino  ## --     
    if not executaExplosao then
        if hero.posX <= 0   then hero.posX = 0   end 
        if hero.posX >= 224 then hero.posX = 224 end
        if hero.posY <= 33  then hero.posY = 33  end 
        if hero.posY >= 138 then hero.posY = 138 end
    end

    -- ## imprime score ## --
    printFont(SCREEN_UP,50,1,hero.points)

    -- ## imprime numero vidas ## --
    controlaVidas()

    -- ## verifica os controles pressionados caso não esteja recarregando oxigenio ## --
    if not sndRecarga.soundPlaying then 
        hero:moveSprite()
        if Keys.newPress.A and not executaExplosao then 
            tiro:shot(hero.direction,hero.posX,hero.posY,hero.width)
            sndTiro.soundActive = true
        end
    end

    -- ## toca o som se necessario -- ##
    if not tocaSirene then sndTiro:Play() end -- ## so faz barulho de tiro se a siren não estiver ligada ## --
    -- ## ativa o som da sirene ## --
    if not sndSirene.soundPlaying and tocaSirene then 
        sndSirene.soundActive = true
    end
    sndSirene:Play()

    sndExplosao:Play()
    sndPegou:Play()
    sndRecarga:Play()


    -- ## movimenta person ## --
    hero:putSprite()

    -- ## controla animacao mar  ## --
    controlaMovimentoMar()

    -- ## controla o submarino da superficie  ## --
    movimentaSubSuperficie()


    -- ## anima os sprites caso não tenha explodido ## --
    if not executaExplosao then 
        -- ## move balas se existirem ## --
        tiro:moveBullets()
    
        -- ## acoes inimigos ## --
        createInimigos()
        moveInimigos()
    
        -- ## acoes mergulhadores ## --
        createMergulhador()
        moveMergulhadores()
    end

    -- ## verifica as colisoes do tiros com os inimigos ## --
	for i = 0, table.maxn(tiro.bullet) do
    	for n = 0, table.maxn(sprite) do
           if spriteCollided(tiro.bullet[i],sprite[n]) then 
                -- ## libera o duto para insercao de um novo inimigo ## --
                duto[n] = false
                -- ## libera o sprite para ser reutilizado ## --
                sprite[n]:disable()
                -- ## atribui pontos do inimigo para o personagem principal ## --
                hero.points = hero.points + sprite[n].points  
           end
        end    
    end

    -- ## verifica colisao do submarino com os inimigos ## -- 
    if verificaColisaoHero() then
        --destroiHero()
        executaExplosao = true
        sndExplosao.soundActive = true
        -- ## posiciona a explosao no local onde estava o submarino ## --
        boom.posX = hero.posX
        boom.posY = hero.posY
        -- ## transfere o subamrino para uma posicao negativa - some da tela ## --
        hero.posX = -200
        hero.posY = 1200
    end 

    -- ## executa processo de explosao ## --
    if executaExplosao then
        explodeSub()
    end


    -- ## verifica se o subamrino resgatou o mergulhador ## --
    if totMergResgatados <= metaResgateMergulhadores then 
        for ni = 0, table.maxn(sprMergulhador) do
            if spriteCollided(hero,sprMergulhador[ni]) then 
                hero.points = hero.points + sprMergulhador[ni].points
                totMergResgatados  = totMergResgatados + 1
                resgataMergulhador(ni)
                sndPegou.soundActive = true
            end
        end    
    end


    -- ## module - Debug ## --
    if habilitaDebug then 
        screen.print(SCREEN_DOWN, 0, 184, "FPS: "..NB_FPS)
        screen.print(SCREEN_DOWN, 0, 0, "Press START to quit")
        screen.print(SCREEN_DOWN, 0, 150, hero:getFrame()) 
      --debugInimigo()
        music:debug()
        tiro:debug()
    end


    -- ## verifica se atingiu pontuacao para ganhar vida extra ## --
    vidaExtra()

    -- ## verifica quando o jogador não possui mais vidas ## --  
    if vidas <= 0 then   
        fluxoExecucaoGame = 3
        controlaFluxoGameOver = 0
        permiteJogar = false
        vidas              = 3 
        totMergResgatados  = 0
        velocidadeInimigos = 1
        ajustaDificuldade  = 1000
        controlaDificuldadeAparicaoSubSuperficie = 50
        hero.points = 0
        controlaVidaExtraObtida = 0
        controlaDificuldadeSaidaOxigenio = 60
    end


    -- ## fim do fluxo de execucao do game ## -- 
end