-- ## Begin : classe Gun ## --
Gun = {}
function Gun:new(imgPointer,scrLocation,speedValue,numBullets)
  local obj = { imagePointer=imgPointer, screenLocation=scrLocation, speed=speedValue, numberBullets=numBullets-1, bullet=nil,slot=nil}
  setmetatable(obj, { __index = Gun })
  return obj
end
    -- ## Methods definition ## -- 
    -- [Bullets] --
    function Gun:createBullets()
        self.bullet = {}
        self.slot = {}
        local i 
        for i = 0, self.numberBullets do
            self.bullet[i] = Sprite:new(self.imagePointer,self.screenLocation,i,-100,-100,1,self.speed,Image.width(self.imagePointer),Image.height(self.imagePointer),1,0)
            self.bullet[i].active = false
            self.slot[i] = false
    	end
    end
    function Gun:addBullet()
        local nextBullet = self.numberBullets + 1
        self.bullet[nextBullet] = Sprite:new(self.imagePointer,self.screenLocation,i,-100,-100,1,self.speed,Image.width(self.imagePointer),Image.height(self.imagePointer),1,0)
        self.bullet[nextBullet].active = false
        self.slot[i] = false
        self.numberBullets = self.numberBullets + 1
    end
    function Gun:getNumBullets()
        return table.maxn(self.bullet)
    end
    -- [Shot] --
    function Gun:shot(directionValue,posxValue,posyValue,widthSprite)
        local tempCounter = 0
        while tempCounter <= self.numberBullets do
            if not self.slot[tempCounter] then 
                self.slot[tempCounter] = true
                if directionValue == 1 then  
                    self.bullet[tempCounter].posX = posxValue + widthSprite - 7
                else
                    self.bullet[tempCounter].posX = posxValue
                end

                self.bullet[tempCounter].posY = posyValue + 6
                self.bullet[tempCounter].direction = directionValue
                self.bullet[tempCounter].active = true
                tempCounter = table.maxn(self.bullet) + 2
            end
            tempCounter = tempCounter + 1
        end
    end

    -- [move bullet] --
    function Gun:moveBullets()
        local i
        for i = 0, self.numberBullets do
            if self.slot[i] then 
                self.bullet[i]:AutoHorizontalMoviment(false)
                self.bullet[i]:putSprite()
                if not self.bullet[i].active then 
                    self.slot[i] = false
                end
            end
        end
    end
  
    -- [Get Bullet] --
    function Gun:getBullets()
        return self.bullet
    end
  
    -- [move bullet] --
    function Gun:showBullet(x,y)
        local i
        for i = 0, self.numberBullets do
            self.bullet[i].posX = x
            self.bullet[i].posY = (y*i)
            self.bullet[i].active = true
            self.bullet[i]:putSprite()
        end
    end      

    -- [Debug] --    
    function Gun:debug()
        local strDebugBullets = ""
        local strDebugDirection = ""
        local strDebugX = ""
        local strDebugY = ""
        local strDebugAtivo = ""
        for i = 0, self.numberBullets do
           if self.bullet[i].active then 
            strDebugAtivo = strDebugAtivo .. "true" .. "|"
           else 
            strDebugAtivo = strDebugAtivo .. "false" .. "|"
    	   end
           if self.slot[i] then 
              strDebugBullets = strDebugBullets .. "A|"
           else
              strDebugBullets = strDebugBullets .. "-|"
           end
        end
        for i = 0, self.numberBullets do
    	   if self.slot[i] then 
              strDebugDirection = strDebugDirection .. self.bullet[i].direction .. "|"
           else
              strDebugDirection = strDebugDirection .. "-|"
           end
        end

        for i = 0, self.numberBullets do
    	   if self.slot[i] then 
              strDebugX = strDebugX .. self.bullet[i].posX .. "|"
              strDebugY = strDebugY .. self.bullet[i].posY .. "|"
           else
              strDebugX = strDebugX .. "-|"
              strDebugY = strDebugY .. "-|"
           end
        end

        

       screen.print(SCREEN_DOWN, 0, 80, "tiro:"..strDebugBullets)        
       screen.print(SCREEN_DOWN, 0, 90, "Dir :"..strDebugDirection)

       screen.print(SCREEN_DOWN, 0, 100, "X:"..strDebugX)        
       screen.print(SCREEN_DOWN, 0, 110, "Y:"..strDebugY)
       screen.print(SCREEN_DOWN, 0, 130, "Ativo:"..strDebugAtivo)

    end 