-- ## Begin : classe Module Music ## --
ModuleMusic = {}
function ModuleMusic:new(modFile,volumeValue)
  local obj = { moduleFile=modFile,volume=volumeValue,modulePointer=nil}
  setmetatable(obj, { __index = ModuleMusic })
  return obj
end
    -- ## Methods definition ## -- 
    -- [Init] --
    function ModuleMusic:init()
        local tempVolumevalue = self.volume 
        self.volume = Mod.initVolume(self.moduleFile)
        Mod.setVolume(tempVolumevalue)
    end
    -- [Module File] --
    function ModuleMusic:setModuleFile(value)
        self.moduleFile = value
    end
    function ModuleMusic:getModuleFile()
        return self.moduleFile
    end
    -- [Volume] --
    function ModuleMusic:setVolume(value)
        self.volume = value
        Mod.setVolume(self.volume)
    end
    function ModuleMusic:getVolume()
        return self.volume
    end
    -- [load] --
    function ModuleMusic:loadModule()
        self.modulePointer = Mod.load(self.moduleFile)
    end
    -- [delete] --
    function ModuleMusic:deleteModule()
        Mod.destroy(self.modulePointer)
    end
    -- [Play] --
    function ModuleMusic:play()
        Mod.play(self.modulePointer)
    end
    -- [Stop] --
    function ModuleMusic:stop()
        Mod.stop()
    end
    -- [Pause] --
    function ModuleMusic:pause()
        Mod.pauseResume()
    end
    -- [Resume] --
    function ModuleMusic:resume()
        Mod.pauseResume()
    end
    -- [Resume] --
    function ModuleMusic:getTime()
        return Mod.time(self.modulePointer)
    end
    -- [isPlaying] --
    function ModuleMusic:isPlaying()
        if Mod.isActive() then 
            return true
        else
            return false
        end
    end

    -- [Debug] --
    function ModuleMusic:debug()
        if Mod.isActive() and habilitaDebug then 
            screen.print(SCREEN_DOWN, 0, 100, "Carregando..")
        else
            screen.print(SCREEN_DOWN, 0, 100, "Tocando..")    
        end
    end

-- ## End : classe Music Module ## -- 
