-- ## Begin : classe Sprite ## --
Sprite = {}
function Sprite:new(imgPointer,scrLocation,sprNum,X,Y,D,S,W,H,F,P)
  local obj = { imagePointer=imgPointer, screenLocation=scrLocation, spriteNumber=sprNum, posX=X, posY=Y, direction=D, speed=S, width=W, height=H, maxFrames=F, frame=0, changeFrame=16, ctrlChangeFrame=0, active=true, points=P}
  setmetatable(obj, { __index = Sprite })
  return obj
end
    -- ## Methods definition ## -- 
    -- [Sprite Number] --
    function Sprite:getSpriteNumber()
        return self.spriteNumber
    end
    -- [Speed] --
    function Sprite:setSpeed(value)
        self.speed = value
    end
    function Sprite:getSpeed()
        return self.speed
    end
    -- [Direction] --
    function Sprite:setDirection(value)
        self.direction = value
    end
    function Sprite:getDirection()
        return self.direction
    end
    -- [Postion X] --
    function Sprite:setPosX(value)
        self.posX = value
    end
    function Sprite:getPosX()
        return self.posX
    end
    -- [Postion X] --
    function Sprite:setPosY(value)
        self.posY = value
    end
    function Sprite:getPosY()
        return self.posY
    end
    -- [Postion Width] --
    function Sprite:setWidth(value)
        self.width = value
    end
    function Sprite:getWidth()
        return self.width
    end
    -- [Postion Heigth] --
    function Sprite:setHeight(value)
        self.height = value
    end
    function Sprite:getHeight()
        return self.height
    end

    -- [Active] --
    function Sprite:setActive(value)
        self.active = value
    end
    function Sprite:getActive()
        return self.active
    end

    -- [Disable] --
    function Sprite:disable()
        self.active = false
        self.posX = -100
        self.posY = -100
    end

    -- [Automatic horizontal moviment ] --
    function Sprite:AutoHorizontalMoviment(loop)
        if self.active then
            if self.direction == 1 then 
                self.posX = self.posX + self.speed
                if self.posX >= 240 then 
                    if loop then  
                        self.posX      = 240
                        self.direction = 0
                    else
                        self.active = false
                        self.posX = -100
                        self.posY = -100
                    end
                end
            else
                self.posX = self.posX - self.speed
                if self.posX <= 0 then 
                    if loop then
                        self.posX      = 0
                        self.direction = 1
                    else
                        self.active = false
                        self.posX = -100
                        self.posY = -100
                    end
                end
            end
        end
    end
    -- [Automatic Vertical moviment ] --
    function Sprite:AutoVerticalMoviment(loop)
        if self.active then
            if self.direction == 1 then 
                self.posY = self.posY + self.speed
                if self.posY >= 190 then 
                    if loop then
                        self.posY      = 190
                        self.direction = 0
                    else
                        self.active = false
                        self.posX = -100
                        self.posY = -100
                    end
                end
            else
                self.posX = self.posX - self.speed
                if self.posY <= 0 then 
                    if loop then
                        self.posY      = 0
                        self.direction = 1
                    else
                        self.active = false
                        self.posX = -100
                        self.posY = -100
                    end
                end
            end
        end
    end
    -- [Put Sprite] --
    function Sprite:putSprite()
        if self.active then 
            if self.maxFrames == 1 then 
                screen.blit(self.screenLocation, self.posX, self.posY, self.imagePointer,0,0,self.width,self.height)
            else
                --if self.direction == 1 then 
                self.ctrlChangeFrame = self.ctrlChangeFrame + 1
                if self.ctrlChangeFrame == self.changeFrame then
                    self.ctrlChangeFrame = 0
                    self.frame = self.frame + 1
                    if self.frame >= self.maxFrames then 
                         --printFont(SCREEN_DOWN,0,50,"ENTROU")
                         self.frame = 0
                    end 
                end
                if self.direction == 0 then 
                    --screen.blit(self.screenLocation, self.posX, self.posY, self.imagePointer,  0 ,  0, self.width , self.height)
                    screen.blit(self.screenLocation, self.posX, self.posY, self.imagePointer,  (self.frame*self.width) ,  0, self.width , self.height)
                else
                    --screen.blit(self.screenLocation, self.posX, self.posY, self.imagePointer,  0 ,  0, self.width , self.height)
                    screen.blit(self.screenLocation, self.posX, self.posY, self.imagePointer,  (self.frame*self.width) ,  self.height, self.width , self.height)
                end
            end
        end
    end 
    -- ## move sprite ## --
	function Sprite:moveSprite()
        if Keys.held.Up    then  
           self.posY = self.posY - self.speed
       	   self.direction = self.direction 
        end
    	if Keys.held.Right then  
           self.posX = self.posX + self.speed 
       	   self.direction = 1
        end
    	if Keys.held.Down  then  
           self.posY = self.posY + self.speed
       	   self.direction = self.direction 
        end
    	if Keys.held.Left  then  
            self.posX = self.posX - self.speed 
       	   self.direction = 0
        end
    end
    -- ## frame ## --
    function Sprite:setFrame(value)
        self.frame = value
    end
    function Sprite:getFrame()
        return self.frame
    end

-- ## End : classe Sprite ## -- 
